n = 1000;
m = round(n*1.2); 

fprintf('matrix size:   m =  %4.0f,  n = %4.0f \n', m,n')
fprintf('Residuals and orthogonality measure should be of the order of 10^(-15).\n')

fprintf('=====Polar decomposition=====\n')
A = randn(n);
[U,H] = zolopd(A);
fprintf('QDWHEIG   :       residual = %9.2e, orthogonality = %9.2e\n', ...
          norm(U*H-A,'fro')/norm(A,'fro'), norm(U'*U-eye(n),'fro')/sqrt(n))
      
fprintf('=====Symmetric eigendecomposition=====\n')
A = randn(n); A=A'+A;
[V,D] = zoloeig(A);
fprintf('ZOLOEIG   :       residual = %9.2e, orthogonality = %9.2e\n', ...
          norm(A-V*diag(D)*V','fro')/norm(A,'fro'), norm(V'*V-eye(n),'fro')/sqrt(n))
[V,D] = eig(A);
fprintf('MATLAB eig:       residual = %9.2e, orthogonality = %9.2e\n\n', ...
norm(A-V*D*V','fro')/norm(A,'fro'), norm(V'*V-eye(n),'fro')/sqrt(n))

fprintf('=====Singular value decomposition=====\n')
A = randn(m,n);
[U,S,V] = zolosvd(A);
fprintf('ZOLOSVD   :       residual = %9.2e, orthogonality = %9.2e\n', ...
          norm(A-U*diag(S)*V','fro')/norm(A,'fro'), max(norm(U'*U-eye(n),'fro')/sqrt(n),norm(V'*V-eye(n),'fro')/sqrt(n)))
[U,S,V] = svd(A,0);
fprintf('MATLAB svd:       residual = %9.2e, orthogonality = %9.2e\n', ...
          norm(A-U*S*V','fro')/norm(A,'fro'), max(norm(U'*U-eye(n),'fro')/sqrt(n),norm(V'*V-eye(n),'fro')/sqrt(n)))

